c$Id:$
      subroutine umacr22(lct,ctl)

c      * * F E A P * * A Finite Element Analysis Program

c....  Copyright (c) 1984-2015: Regents of the University of California
c                               All rights reserved

c-----[--.----+----.----+----.-----------------------------------------]
c      Purpose:   User interface for UMFPACK Sparse Matrix Package solver

c      Inputs:
c         lct       - Command character parameters
c         ctl(3)    - Command numerical parameters

c      Outputs:
c         solver    - Indicates user solver or system solver
c                     .true.  = system solver
c                     .false. = user solver
c-----[--.----+----.----+----.-----------------------------------------]
      implicit  none

      include  'fdata.h'
      include  'iofile.h'
      include  'part0.h'
      include  'setups.h'
      include  'umac1.h'

      logical   pcomp, setvar,palloc
      character lct*15,tname*5
      real*8    ctl(3)

      save

c     Install command UMFP (for UMFPACK Sparse Matrix Package)

      if(pcomp(uct,'ma22',4)) then

        write(*,2000) 'UMFP'
        uct = 'umfp'

c     Set solver type

      else

        if(pcomp(lct,'off',3)) then
          solver = .true.
          setvar = palloc(225,'USOL1', 0,1)
          setvar = palloc(226,'USOL2', 0,1)
          write(tname,'(4hTANG,i1)') npart
          setvar = palloc(npart,tname, 0,2)
        else
          solver = .false.
          if(pfr) then
            write(iow,2001)
            if(ior.lt.0) then
              write(*,2001)
            endif
          endif
        endif

      endif

2000  format(/' --> User solver ',a,' installed'/)
2001  format( '  UMFPACK Sparse Solver'/)

      end
